<?php // Include only
if (!defined ('BOOT')) exit ('No bootstrap.  Exiting.');

/*
Wacintaki Poteto Pic Save Functions
Copyright 2004-2007 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.8 - Last modified 6/19/2007
*/


function make_edit_pass($source) {
	global $cfg;
	return (crypt ($source, $cfg['salt']));
}


function verify_edit($testnum, $user_pass = '') {
	// Need DB, username, password
	global $dbconn, $OekakiPoteto_Prefix, $OekakiPoteto_MemberPrefix, $OekakiU, $OekakiPass;

	// Process password (encoded)
	if (!empty ($user_pass)) {
		$user_pass = stripslashes ($user_pass);
	}

	$result = mysql_query ("SELECT usrname, password FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$testnum'");
	$row = mysql_fetch_array ($result);
	$result2 = mysql_query ("SELECT usrpass FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$OekakiU'");
	$row2 = mysql_fetch_array ($result2);

	if ($OekakiU != $row['usrname'] || $OekakiPass != $row2['usrpass']) {
		// Not artist pic.  Edit w/password?
		if (make_edit_pass($row['password']) == $user_pass) {
			return $testnum;
		} else {
			return 0;
		}
	} else {
		// Artist pic
		return $testnum;
	}
}


function get_new_picnumber() {
	// Need DB
	global $dbconn, $OekakiPoteto_Prefix;

	// Get piccount
	$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakimisc SET miscvalue=(miscvalue + 1) WHERE miscname='piccount'");
	$result = mysql_query ("SELECT miscvalue FROM {$OekakiPoteto_Prefix}oekakimisc WHERE miscname='piccount'");

	return mysql_result ($result, 0);
}


function kill_post_files($resno) {
	// Need DB, names
	global $dbconn, $OekakiPoteto_Prefix;
	global $p_pic, $r_pic, $t_pic;

	$kpf_result = mysql_query ("SELECT datatype, animation, ttype, ptype, rtype FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='{$resno}'");
	if (!$kpf_result) {
		return FALSE;
	}
	$row = mysql_fetch_array ($kpf_result);

	// Remove animation
	if ($row['animation'] == 1) {
		if ($row['datatype'] == 0 || $row['datatype'] == 2 || $row['datatype'] == 3) {
			file_unlock ($p_pic.$resno.'.pch');
		} elseif ($row['datatype'] == 1) {
			file_unlock ($p_pic.$resno.'.oeb');
		}
	}

	// Remove images
	if (!empty ($row['ptype'])) {
		file_unlock ($p_pic.$resno.'.'.$row['ptype']);
	}
	if (!empty ($row['ttype'])) {
		file_unlock ($t_pic.$resno.'.'.$row['ttype']);
	}
	if (!empty ($row['rtype'])) {
		file_unlock ($r_pic.$resno.'.'.$row['rtype']);
	}
	return TRUE;
}


function kill_picture_slot($resno) {
	// Need DB, names
	global $dbconn, $OekakiPoteto_Prefix;
	global $p_pic, $r_pic, $t_pic;

	// Remove all post files
	kill_post_files($resno);

	// Now delete the DB entries
	$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE PIC_ID='{$resno}'");
	$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='{$resno}'");

	return TRUE;
}


function clean_picture_slots() {
	// This function may be called any time (refresh op)

	// Need CFG, DB, names
	global $cfg, $dbconn, $OekakiPoteto_Prefix, $p_pic, $r_pic, $t_pic;

	// Get slots to delete
	$result = mysql_query ("SELECT COUNT(ID_2) FROM {$OekakiPoteto_Prefix}oekakidta");
	if (!$result)
		return FALSE;

	$total_slots = (int) mysql_result ($result, 0);

	// If total rows is more than allowed, trim non-archived pics
	$trim_slots = $total_slots - $cfg['pic_store'];
	if ($trim_slots > 0) {
		// Don't blow up
		if ($trim_slots > 10)
			$trim_slots = 10;

		// Remove oldest, non-archived pictures
		$result = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta WHERE archive=0 ORDER BY postdate ASC LIMIT {$trim_slots}");

		while ($result && ($row = mysql_fetch_array ($result))) {
			kill_picture_slot($row['PIC_ID']);
		}
	}

	return TRUE;
}


function fix_thumbnail($picnumber, $new = TRUE) {
	// Need DB, names
	global $dbconn, $OekakiPoteto_Prefix, $p_pic, $r_pic, $t_pic;

	// Replace thumbnail for $picnumber.  If !$new, just delete
	$result = mysql_query ("SELECT PIC_ID, ptype, rtype, ttype FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID={$picnumber}");
	$row = mysql_fetch_array ($result);

	// Remove old (Win32 safe)
	if (!empty ($row['ttype'])) {
		file_unlock($t_pic.$picnumber.'.'.$row['ttype']);
	}
	if (!empty ($row['rtype'])) {
		file_unlock ($r_pic.$picnumber.'.'.$row['rtype']);
	}

	if ($new) {
		save_thumbnail($row['PIC_ID'], $row['ptype']);
	} else {
		mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET ttype='', rtype='', usethumb=0 WHERE PIC_ID='{$row['PIC_ID']}'");
	}
}


function save_thumbnail($picnumber, $p_ext, $force_thumb = FALSE, $force_type = '') {
	// Need CFG, DB, names
	global $dbconn, $OekakiPoteto_Prefix;
	global $cfg;
	global $p_pic, $r_pic, $t_pic;


	// If thumbnail mode is off
	if ($cfg['use_thumb'] == 0) {
		return 1;
	}


	// Test for GDlib
	if (extension_loaded ('gd')) {
		// Set up file names
		$image_source = $p_pic.$picnumber.'.'.$p_ext;
		$image_t = $t_pic.$picnumber.'.';
		$image_r = $r_pic.$picnumber.'.';


		// Get file properties: size, area, longer side
		$p_filesize = filesize ($image_source);
		$p_sizes    = @GetImageSize ($image_source);
		$p_area     = $p_sizes[0] * $p_sizes[1];
		if ($p_sizes[0] < $p_sizes[1]) {
			$long_mode  = 1;
			$long_side  = $p_sizes[1];
			$short_side = $p_sizes[0];
		} else {
			$long_mode  = 0;
			$long_side  = $p_sizes[0];
			$short_side = $p_sizes[1];
		}


		// Determine if thumbnails should be made
		$usethumb = 0; // Flag for filesize limit
		$make_t   = 1;
		$make_r   = 0;
		if ($long_side <= $cfg['thumb_t'] || $p_filesize < 15000) {
			// No sense in making a thumbnail if already tiny, or small filesize
			$make_t = 0;
		}
		if ($p_filesize > $cfg['thumb_bytes']) {
			// Over the size limit
			$usethumb = 1;
			$make_r = 1;
		}
		if ($long_side > 740) {
			// No matter what, it's too big for 800x600 users
			$make_r = 1;
		}

		// Force thumbnail?
		if ($force_thumb) {
			$make_r = 1;
			$usethumb = 1;
		}


		if ($make_t || $make_r) {
			/*
			OK, here's where things get ugly.  Since most (all?) graphics libraries don't support analysis of the data to choose the correct format, we'll make both PNG and JPEG and choose the smaller.  I don't like brute force methods, but this is no big deal since our images are tiny, are not made often, and the time we spend here will greatly affect bandwidth usage.
			*/

			// GDlib is weird and inconsistent, so we'll have to remap some functions
			if (function_exists ('imagecreatetruecolor')) {
				$create_function = 'imagecreatetruecolor';
				$resize_function = 'imagecopyresampled';
			} else {
				$create_function = 'imagecreate';
				$resize_function = 'imagecopyresized';
			}

			switch ($p_ext) {
				// Really weird.
				case 'gif':
					if (!function_exists ('imagecreatefromgif')) {
						// No GIF support!  Nothing we can do
						// Not an error, so return OK
						return 1;
					} else {
						$source = @imagecreatefromgif ($image_source);
					}
					break;
				case 'png':
					$source = @imagecreatefrompng ($image_source);
					break;
				case 'jpg':
					$source = @imagecreatefromjpeg ($image_source);
					break;
				default:
					// Not an image file [supported by GD]
					return 0;
			}

			// Did GD barf?
			if (!$source) {
				return 0;
			}


			// Time to make the doughnuts.  A new function will replace this mess shortly
			if ($make_t) {
				// GD doesn't support scaling (!)
				$ratio  = $cfg['thumb_t'] / $long_side;
				$lesser_t = round ($short_side * $ratio);

				if ($long_mode == 0) {
					$new_t = $create_function($cfg['thumb_t'], $lesser_t);
					$resize_function($new_t, $source, 0, 0, 0, 0, $cfg['thumb_t'], $lesser_t, $p_sizes[0], $p_sizes[1]);
				} else {
					$new_t = $create_function($lesser_t, $cfg['thumb_t']);
					$resize_function($new_t, $source, 0, 0, 0, 0, $lesser_t, $cfg['thumb_t'], $p_sizes[0], $p_sizes[1]);
				}


				// Hard-coded format for now.
				$t_format = 'jpg';
				if ($force_type == 'png') {
					$t_format = 'png';
				}

				switch ($t_format) {
					// Actually, it's kinda stupid
					case 'png':
						file_unlock($image_t.'png');
						@imagepng ($new_t, $image_t.'png');
						break;
					case 'jpg':
						file_unlock($image_t.'jpg');
						@imagejpeg ($new_t, $image_t.'jpg', $cfg['thumb_jpg']);
						break;
				}
				imagedestroy ($new_t);
			}

			if ($make_r) {
				$ratio  = $cfg['thumb_r'] / $long_side;
				$lesser_r = round ($short_side * $ratio);

				if ($long_mode == 0) {
					$new_r = $create_function($cfg['thumb_r'], $lesser_r);
					$resize_function($new_r, $source, 0, 0, 0, 0, $cfg['thumb_r'], $lesser_r, $p_sizes[0], $p_sizes[1]);
				} else {
					$new_r = $create_function($lesser_r, $cfg['thumb_r']);
					$resize_function($new_r, $source, 0, 0, 0, 0, $lesser_r, $cfg['thumb_r'], $p_sizes[0], $p_sizes[1]);
				}


				// Hard-coded format for now
				$r_format = 'jpg';
				if ($force_type == 'png') {
					$r_format = 'png';
				}

				switch ($r_format) {
					case 'png':
						file_unlock($image_r.'png');
						$image_r .= 'png';
						@imagepng ($new_r, $image_r);
						break;
					case 'jpg':
						file_unlock($image_r.'jpg');
						$image_r .= 'jpg';
						@imagejpeg ($new_r, $image_r, $cfg['thumb_jpg']);
						break;
				}
				imagedestroy ($new_r);
			}
			imagedestroy ($source);


			// Test to see if we made some progress
			if (file_exists ($image_r) && (filesize ($image_r) > filesize ($image_source) * 0.92)) {
				if (!$force_thumb) {
					// Not worth it.  People will effectively download images twice, doubling bandwidth usage.
					if (@file_unlock ($image_r)) {
						$usethumb = 0;
						$make_r = 0;
					}
				}
			}

			// Update SQL
			$sql  = "UPDATE {$OekakiPoteto_Prefix}oekakidta SET";
			$sql2 = "WHERE PIC_ID='$picnumber'";
			if ($make_t) {
				mysql_query ($sql." ttype='{$t_format}' ".$sql2);
			}
			if ($make_r) {
				mysql_query ($sql." rtype='{$r_format}', usethumb='{$usethumb}' ".$sql2);
			} else {
				// Fixes issue with forced thumbnails
				mysql_query ($sql." usethumb='0' ".$sql2);
			}
		}

		// 1=OK, 2=t, 3=r, 4=t+r
		if ($make_r && $make_t) {
			return 4;
		}
		if ($make_r && !$make_t) {
			return 3;
		}
		return 1 + $make_t;

	} else {
		return 0;
	}
}


function save_image(&$data, $picnumber) {
	// Need CFG, DB, names
	global $dbconn, $OekakiPoteto_Prefix;
	global $cfg;
	global $p_pic, $r_pic, $t_pic;

	// save_image() is a monolithic task, so any old images/anims should be wiped out
	kill_post_files($picnumber);

	$type = get_filetype($data);
	if (!$type) {
		// Corrupt data from applet?
		return FALSE;
	}

	$image_file = $p_pic.$picnumber.'.'.$type;

	file_unlock($image_file);
	if ($fp = @fopen ($image_file, 'wb')) {
		// Write main file
		fwrite ($fp, $data, strlen ($data));
		fclose ($fp);

		// I wish I didn't have to do this HERE.
		$sizes = @GetImageSize ($image_file);
		if ($sizes === FALSE) {
			// Corrupt data from applet?
			return FALSE;
		}
		$result = mysql_query ('UPDATE '.$OekakiPoteto_Prefix."oekakidta SET px={$sizes[0]}, py={$sizes[1]}, ptype='$type' WHERE PIC_ID='$picnumber'");
		if (!$result) {
			w_error_log (__FILE__.': Pic size/type for '.$picnumber.' not insterted into DB ('.mysql_error().')');
		}

		if (!save_thumbnail ($picnumber, $type)) {
			// Something wrong with GDlib?  Wrong type?
			// For now, no logging = no clogging.
		}

		return TRUE;
	}

	return FALSE;
}


function save_anim(&$data, $picnumber, $extension) {
	// Need CFG, names
	global $cfg, $p_pic;

	$anim = $p_pic.$picnumber.'.'.$extension;

	file_unlock($anim); // Can't hurt

	if ($fp = @fopen ($anim, 'wb')) {
		// Write main file
		fwrite ($fp, $data, strlen ($data));
		fclose ($fp);

		return 1;
	}
	return 0;
}


function bump_post($resno) {
	// Need DB
	global $dbconn, $OekakiPoteto_Prefix;

	// Update postdate
	$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET postdate=NOW() WHERE PIC_ID='$resno'");

	if (!$result)
		// Can't read post
		return FALSE;

	// Rebuild thumbnail, required for WIP
	fix_thumbnail($resno);

	return TRUE;
}

?>